diff --git a/contrib/amd/FREEBSD-upgrade b/contrib/amd/FREEBSD-upgrade
index 8027e2f..297ca0e 100644
--- a/contrib/amd/FREEBSD-upgrade
+++ b/contrib/amd/FREEBSD-upgrade
@@ -1,20 +1,19 @@
 # ex:ts=8
-$FreeBSD: src/contrib/amd/FREEBSD-upgrade,v 1.11 1999/11/05 11:59:47 obrien Exp $
-$DragonFly: src/contrib/amd/FREEBSD-upgrade,v 1.2 2003/06/17 04:23:51 dillon Exp $
-
-AMD (am-utils) 6.0.3s1
-    originals can be found at: ftp://shekel.mcl.cs.columbia.edu/pub/am-utils/
-    (http://www.cs.columbia.edu/~ezk/am-utils/index.html)
+$FreeBSD: src/contrib/amd/FREEBSD-upgrade,v 1.17 2012/11/17 01:48:41 svnexp Exp $
 
+AMD (am-utils) 6.1.5
+    originals can be found at: ftp://ftp.am-utils.org/pub/am-utils/
 
 For the import of AMD many files were pruned by:
 
-	tar -X FREEBSD-Xlist -xzf am-utils-6.0.3s1.tar.gz
+	tar -X FREEBSD-Xlist -xf am-utils-6.1.5.tar.gz
+
+and `find . -name '.cvsignore' -delete`
 
 Then imported by:
 
-	cvs import -m 'Virgin import of AMD (am-utils) v6.0.3s1' \
-		src/contrib/amd COLUMBIA amd_6_0_3s1
+	cvs import -m 'Virgin import of AMD (am-utils) v6.1.5' \
+		src/contrib/amd COLUMBIA amd_6_1_5
 
 After the import, a separate extraction of am-utils was GNU configured in
 the "normal" way.  The resulting config.h file should be compared with
@@ -24,8 +23,78 @@ updated as needed.
 To make local changes to amd, simply patch and commit to the main
 branch (aka HEAD).  Never make local changes on the vendor (COLUMBIA) branch.
 
-All local changes should be submitted to "amd-dev@majordomo.cs.columbia.edu"
-for inclusion in the next vendor release.
+Note, we don't trim anything in scripts/ as sysadmins may find the bits
+as a useful reference.
+
+All local changes should be submitted to "am-utils@am-utils.org" or
+https://bugzilla.am-utils.org for inclusion in the next vendor release.
+
+Local changes:
+
+	amd/amd.8
+	  r1.17 Uniformly refer to a file system as "file system"
+	  r1.16 Add the am-utils homepage to SEE ALSO
+	  r1.15 s/BSD/.Bx/ where appropriate
+	  r1.14 Avoid using parenthesis enclosure macros
+	  r1.13 split punctuation characters + misc fixes
+	  r1.12 mdoc(7)NG
+	  r1.11 Catch a left over reference to "/a"
+	  r1.10 Document change to the default mount dir.
+	  r1.9 Mention "amd -H" in the synopsis
+	  r1.8 Fix miscellaneous mdoc macro argument limit infringements
+	  r1.7 Don't refer to non-existent automount(8)
+	  r1.6 Fix errors in .Xr usage
+	  r1.3 un-mandocafied, un4.4BSD'ed
+	  r1.2 sort cross references
+	amd/amd.c
+	  r1.7 use /.amd_mnt as default for -a
+	amq/amq.8
+	  r1.9 Uniformly refer to a file system as "file system".
+	  r1.8 s/BSD/.Bx/ where appropriate.
+	  r1.6 mdoc(7)NG.
+	  r1.5 Remove reference to non-existent manpage
+	  r1.4 Fix typos
+	  r1.3 un-mandocafied, un4.4BSD'ed
+	amq/pawd.1
+	  r1.3 un-mandocafied, un4.4BSD'ed
+	  r1.2 sorting of references
+	conf/nfs_prot/nfs_prot_freebsd3.h
+	  r1.11 Userland part of nfs client/server split and cleanup
+	  r1.6 restore the standard name nfs_fh3
+	  r1.3 Fully use our own generated files for NFSv3
+	  r1.2 rpcgen our own files for NFSv3 support
+	fixmount/fixmount.8
+	  r1.8 Uniformly refer to a file system as "file system"
+	  r1.6 split punctuation characters + misc fixes.
+	  r1.5 mdoc(7)NG.
+	  r1.4 ".Mn mountd" -> ".Nm mountd"
+	  r1.3 un-mandocafied, un4.4BSD'ed
+	  r1.2 More sorting of references.
+	fsinfo/fsinfo.8
+	  r1.9 add section number to .Xr directive
+	  r1.7 Uniformly refer to a file system as "file system"
+          r1.6 split punctuation characters + misc fixes
+	  r1.5 mdoc(7)NG
+	  r1.3 describe all of the command line options
+	  r1.2 un-mandocafied, un4.4BSD'ed
+	mk-amd-map/mk-amd-map.8
+	  r1.4 removed HISTORY info from the .Os call.
+	  r1.2 un-mandocafied, un4.4BSD'ed
+	scripts/amd.conf.5
+	  r1.15 Bring man page back in shape
+	  r1.13 Uniformly refer to a file system as "file system"
+	  r1.12 Avoid using parenthesis enclosure macros
+	  r1.11 mdoc(7)NG
+	  r1.10 Fix miscellaneous mdoc macro argument limit infringements
+	  r1.8 Fix a bunch of broken cross-references
+	  r1.7 Bad reference of uname(2) -> uname(3)
+	  r1.6 Grammer fix and style nits.
+	  r1.5 xfer typo
+	  r1.4 un-mandocafied, un4.4BSD'ed
+	  r1.3 More sorting of references.
+	wire-test/wire-test.8
+	  r1.2 un-mandocafied, un4.4BSD'ed
 
+mbr@FreeBSD.org
 obrien@NUXI.com
 05-November-1999
diff --git a/contrib/amd/INSTALL b/contrib/amd/INSTALL
index 8a21b41..273fe02 100644
--- a/contrib/amd/INSTALL
+++ b/contrib/amd/INSTALL
@@ -1,108 +1,99 @@
-# -*- text -*-
-		      am-utils 6.0 compatibility list
+		      am-utils 6.1 compatibility list
 
 For each system, list if it autoconfigures, compiles, or runs.  Fill in
 email id of person who confirms the fact.  A missing entry means unverified.
-A 'no' or '!' means verified broken or nonexistent (static library).
+A 'no' or 'X' means verified broken or nonexistent (static library).
+
+SYSTEM				CONFIG	COMPILE	RUN	SHLIB	AUTOFS
+=========================	=======	=======	=======	=======	======
+alpha-dec-osf4.0f		ro	ro	ro	-	-
+alpha-dec-osf5.1		ro	ro	ro	-	-
+alpha-unknown-linux-gentoo1.4.16 ezk	ezk	ezk	ezk	-
+alphaev56-dec-osf4.0f		ezk	ezk	ezk	ezk	-
+i386-apple-darwin6.0		ezk	ezk	ezk	ezk	-
+i386-pc-bsdi2.1			ion	ion	ion	ion[X]	ion[X]
+i386-pc-linux-deb3.0		ezk	ezk	ezk	ezk	-
+i386-pc-linux-deb3.1		ezk	ezk	ezk	ezk	-
+i386-pc-linux-fc1		ezk	ezk	ezk	ezk	-
+i386-pc-linux-fc2		ezk	ezk	ezk	ezk	-
+i386-pc-linux-fc3		ezk	ezk	ezk	ezk	-
+i386-pc-linux-fc4		ezk	ezk	ezk	ezk	-
+i386-pc-linux-gentoo1.4.16	ezk	ezk	ezk	ezk	-
+i386-pc-linux-rh6.2		ion	ion	ion	ion	ion
+i386-pc-linux-rh7.1		ion	ion	ion	ion	ion
+i386-pc-linux-rh7.2		ion	ion	ion	ion	ion
+i386-pc-linux-rh7.3		ion	ion	ion	ion	ion
+i386-pc-linux-rh8.0		ezk	ezk	ezk	ezk	-
+i386-pc-linux-rh9		ion	ion	ion	ion	ion
+i386-pc-linux-rhel3		ezk	ezk	ezk	ezk	-
+i386-pc-linux-rhel4		ezk	ezk	ezk	ezk	-
+i386-pc-linux-suse8.2		ezk	ezk	ezk	ezk	-
+i386-pc-linux-suse9.1		ezk	ezk	ezk	ezk	-
+i386-pc-linux-suse9.2		ezk	ezk	ezk	ezk	-
+i386-pc-linux-suse9.3		ezk	ezk	ezk	ezk	-
+i386-pc-solaris2.10		ro	ro	ro	-	-
+i386-pc-solaris2.9		ro	ro	ro	-	-
+i386-unknown-freebsd4.10	ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd4.11	ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd4.8		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd4.9		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd5.0		ezk	ezk	-	ezk	-
+i386-unknown-freebsd5.1		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd5.2		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd5.2.1	ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd5.3		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd5.4		ezk	ezk	ezk	ezk	-
+i386-unknown-freebsd6 (BETA5)	ezk	ezk	ezk	ezk	-
+i386-unknown-netbsd1.6A		ezk	ezk	ezk	ezk	-
+i386-unknown-netbsdelf1.6.1	ezk	ezk	ezk	ezk	-
+i386-unknown-netbsdelf1.6.2	ezk	ezk	ezk	ezk	-
+i386-unknown-netbsdelf2.0	ezk	ezk	ezk	ezk	-
+i386-unknown-netbsdelf2.0.2	ezk	ezk	ezk	ezk	-
+i386-unknown-netbsdelf3.0	ezk	ezk	ezk	ezk	-
+i386-unknown-openbsd3.3		ezk	ezk	ezk	ezk	-
+i386-unknown-openbsd3.6		ezk	ezk	ezk	ezk	-
+i386-unknown-openbsd3.7		ezk	ezk	ezk	ezk	-
+i686-apple-darwin6.6		ezk	ezk	ezk	ezk	-
+ia64-hp-hpux11.20		ezk	ezk	ezk	ezk	-
+ia64-unknown-linux-rh2.1AS	ezk	ezk	-	ezk	-
+ia64-unknown-linux-rh2.1AW	ezk	ezk	ezk	ezk	-
+ia64-unknown-linux-rhel4	ezk	ezk	ezk	ezk	-
+mips-sgi-irix6.2		ro	ro	ro	-	-[3]
+mips-sgi-irix6.5		ro	ro	ro	-	-[3]
+mips-unknown-linux-gentoo1.4.16	ezk	ezk	ezk	ezk	-
+mipsel-unknown-linux-rhPS2	ezk	ezk	ezk	ezk	-
+powerpc-apple-darwin7.6.0	ezk	ezk	ezk	ezk	-
+powerpc-apple-darwin7.7.0	ezk	ezk	ezk	ezk	-
+powerpc-apple-darwin7.8.0	ezk	ezk	ezk	ezk	-
+powerpc-apple-darwin7.9.0	ezk	ezk	ezk	ezk	-
+powerpc-apple-darwin8.2.0	ezk	ezk	ezk	ezk	-
+powerpc-ibm-aix5.1.0.0		ion	ion	ion	ion[X]	ion[1,2]
+powerpc-ibm-aix5.2.0.0		ezk	ezk	ezk	ezk	-
+powerpc-ibm-aix5.3.0.0		ezk	ezk	ezk	ezk	-
+powerpc-unknown-linux-yellowdog2.3 ezk	ezk	ezk	ezk	-
+sparc-sun-solaris2.10		ro	ro	ro	-	-
+sparc-sun-solaris2.5.1		ion	ion	ion	ion	ion[1]
+sparc-sun-solaris2.6		ion	ion	ion	ion	ion
+sparc-sun-solaris2.7		ion	ion	ion	ion	ion
+sparc-sun-solaris2.8		ion	ion	ion	ion	ion
+sparc-sun-solaris2.9		ro	ro	ro	-	-
+sparc-unknown-linux-rh62	ion	ion	ion	ion	ion
+sparc64-unknown-linux-aurora10	ion	ion	ion	ion	ion
+sparc64-unknown-linux-deb3.0	ezk	ezk	ezk	ezk	-
+sparc64-unknown-linux-gentoo1.4.16 ezk	ezk	ezk	ezk	-
+sparc64-unknown-linux-rh62	ion	ion	ion	ion	ion
+sparc64-unknown-linux-suse7.3	ezk	ezk	-	ezk	-
+x86_64-unknown-linux-rh2.9.5AS	ezk	ezk	ezk	ezk	-
+x86_64-unknown-linux-rh3.0.0AS	ion	ion	ion	ion	ion
 
-SYSTEM				AUTOCONF  COMPILE    RUN      SHLIB
-=========================	========  =========  =======  =====
-alpha-dec-osf2.1		ezk       ezk        ezk     !ezk
-alpha-dec-osf4.0		ezk       ezk        dsr[3]   ezk
-alphaev5-unknown-linux-gnu	ezk       ezk        finkel   ezk
-alphaev5-unknown-linux-gnu-rh5.2 ezk      ezk        ezk      ezk
-hppa1.0-hp-hpux11.00		ezk       ezk        ezk
-hppa1.1-hp-hpux10.10		ezk       ezk        ezk      ezk
-hppa1.1-hp-hpux10.20		ezk       ezk        ezk      ezk
-hppa1.1-hp-hpux9.01		ezk[4]    ezk[4]     nrh/ezk  ezk
-hppa1.1-hp-hpux9.05		ezk[4]    ezk[4]     nrh/ezk  ezk
-hppa1.1-hp-hpux9.07		ezk[4]    ezk[4]     nrh/ezk  ezk
-hppa2.0w-hp-hpux11.00		ezk       ezk        ezk      ezk
-i386-pc-bsdi2.1			ezk       ezk        ezk     !ezk
-i386-pc-bsdi3.0			ezk       ezk        ezk     !ezk
-i386-pc-bsdi3.1			ezk       ezk        ezk     !ezk
-i386-pc-bsdi4.0			ezk       ezk        ezk      ezk
-i386-pc-bsdi4.0.1		ezk       ezk        ezk      ezk
-i386-pc-solaris2.5.1		ezk       ezk        ezk      ezk
-i386-pc-solaris2.6		ezk       ezk        ezk      ezk
-i386-pc-solaris2.7		ezk       ezk        ezk      ezk
-i386-unknown-freebsd2.1.0	ezk       ezk        ezk
-i386-unknown-freebsd2.2.1	ezk       ezk        ezk      ezk
-i386-unknown-freebsd2.2.6	ezk       ezk        ezk      ezk
-i386-unknown-freebsd2.2.7	ezk       ezk        ezk      ezk
-i386-unknown-freebsd2.2.8	ezk       ezk        ezk      ezk
-i386-unknown-freebsd3.0		ezk       ezk        ezk      ezk
-i386-unknown-freebsdelf3.0	ezk       ezk        ezk      ezk
-i386-unknown-freebsdelf3.1	ezk       ezk        ezk      ezk
-i386-unknown-freebsdelf3.2	ezk       ezk        ezk      ezk
-i386-unknown-freebsdelf3.3	ezk       ezk        ezk      ezk
-i386-unknown-freebsdelf4.0	ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.2.1	ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.3		ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.3.1	ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.3.2	ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.3.3	ezk       ezk        ezk      ezk
-i386-unknown-netbsd1.4		ezk       ezk        ezk      ezk
-i386-unknown-openbsd2.1		ezk       ezk        ezk      ezk
-i386-unknown-openbsd2.2		ezk       ezk        ezk      ezk
-i386-unknown-openbsd2.3		ezk       ezk        ezk      ezk
-i386-unknown-openbsd2.4		ezk       ezk        ezk      ezk
-i386-unknown-openbsd2.5		ezk       ezk        ezk      ezk
-i486-ncr-sysv4.3.03		ezk       ezk                 ezk
-i486-pc-linux-gnu-rh6.0		ezk       ezk        ezk      ezk
-i486-pc-linux-gnulibc1		ezk       ezk        ezk      ezk
-i486-pc-linux-gnulibc1-rh4.2	ezk       ezk        ezk      ezk
-i486-pc-linux-gnuoldld		ezk       ezk        ezk      ezk
-i586-pc-linux-gnu		ezk       ezk        ezk      ezk
-i586-pc-linux-gnu-rh5.2		ezk       ezk        ezk      ezk
-i586-pc-linux-gnu-rh6.0		ezk       ezk        ezk      ezk
-i586-pc-linux-gnu-rh6.1		ezk       ezk        ezk      ezk
-i586-pc-linux-gnulibc1		ezk       ezk        ezk      ezk
-i586-pc-linux-gnulibc1-rh4.2	ezk       ezk        ezk      ezk
-i686-pc-linux-gnu		ezk       ezk        ezk      ezk
-i686-pc-linux-gnu-rh5.2		ezk       ezk        ezk      ezk
-i686-pc-linux-gnu-rh6.0		ezk       ezk        ezk      ezk
-i686-pc-linux-gnulibc		ezk       ezk        ezk      ezk
-i686-pc-linux-gnulibc1		ezk       ezk        ezk      ezk
-m68k-hp-hpux9.00		ezk[4]    ezk[4]     nrh/ezk
-m68k-next-nextstep3		ezk       ezk        ezk     !ezk
-m68k-sun-sunos4.1.1		ezk       ezk                !ezk
-mips-dec-ultrix4.3		ro        ro         ro
-mips-sgi-irix5.2
-mips-sgi-irix5.3		ezk       ezk        ezk     ezk
-mips-sgi-irix6.2		ezk[1]    ezk[1]     ezk[1]  ezk
-mips-sgi-irix6.4		ezk       ezk        ezk     ezk
-mips-sgi-irix6.5		ezk       ezk                ezk
-powerpc-ibm-aix4.1.5.0		ezk       ezk        wpaul  !ezk
-powerpc-ibm-aix4.2.1.0		ezk       ezk        ezk    !ezk
-powerpc-ibm-aix4.3.1.0		ezk       ezk               !ezk
-powerpc-unknown-linux-gnu	jose      jose       jose
-rs6000-ibm-aix3.2		ezk       ezk        ezk
-rs6000-ibm-aix3.2.5		ezk       ezk        ezk
-rs6000-ibm-aix4.1.4.0		ezk       ezk               !ezk
-rs6000-ibm-aix4.1.5.0		ezk       ezk               !ezk
-sparc-sun-solaris2.3		ezk       ezk        ezk     ezk
-sparc-sun-solaris2.4		ezk       ezk        ezk     ezk
-sparc-sun-solaris2.5		ezk       ezk        ezk     ezk
-sparc-sun-solaris2.5.1		ezk       ezk        ezk     ezk
-sparc-sun-solaris2.6		ezk       ezk[2]     ezk     ezk
-sparc-sun-solaris2.7		ezk       ezk[2]     ezk     ezk
-sparc-sun-sunos4.1.1		ezk       ezk        ezk     ezk
-sparc-sun-sunos4.1.3		ezk       ezk        ezk     ezk
-sparc-sun-sunos4.1.3C		ezk       ezk        ezk     ezk
-sparc-sun-sunos4.1.3_U1		ezk       ezk        ezk     ezk
-sparc-sun-sunos4.1.4		ezk       ezk        ezk     ezk
-sparc-unknown-linux-gnulibc1	ezk       ezk        ezk     ezk
-sparc-unknown-netbsd1.2E	ezk       ezk        ezk
-sparc-unknown-netbsd1.2G	ezk       ezk        ezk
-sparc64-unknown-linux-gnu	ezk	  ezk	     ezk     ezk
 
 EMAIL ID LEGEND:
 
-bking:	Bevis R W King <B.King@ee.surrey.ac.uk>                
+bking:	Bevis R W King <B.King@ee.surrey.ac.uk>
 dsr:	Dan Riley <dsr@mail.lns.cornell.edu>
 ezk:	Erez Zadok <ezk@cs.columbia.edu>
 finkel:	Raphael Finkel <raphael@cs.uky.edu>
+ion:	Ion Badulescu <ion@cs.columbia.edu>
 jose:	Jose Nazario <jose@biocserver.BIOC.CWRU.Edu>
 nrh:	Nick Hall <nrh@dcs.ed.ac.uk>
 ro:	Rainer Orth <ro@TechFak.Uni-Bielefeld.DE>
@@ -112,42 +103,22 @@ wpaul:	Bill Paul <wpaul@ctr.columbia.edu>
 
 FOOTNOTES:
 
-[1] If compiling with cc on Irix 6, then use
-
-	CC="cc -32 -Wl,-woff,84" ./buildall
-
-to build (good) "old style" 32 bit code and suppress stupid linker warnings
-about unused libraries.
-
-Also, to get NFS V3 working, you need these two patches from SGI:
-
-	patch 1615: NFS over TCP 
-	patch 2041: NFS roll-up patch
-
-and then add "-p tcp" to /etc/config/nfsd.options.
-
-[2] If compiling on Solaris 2.6, you need to add -D_LARGEFILE64_SOURCE to
-CFLAGS to enable the 64bit file offset interface:
-
-	make CFLAGS="-O2 -g -D_LARGEFILE64_SOURCE"
-
-If you're using the standard configure script, it will add this flag for you
-automatically.
-
-[3] DU-4.0 may not use NFS (server-side) V3 by default.  You may need to
-adjust /etc/init.d/nfs, and change the nfsd startup line from to
- 
-	if /usr/sbin/nfsd $NUM_NFSD; then
-to
-	if /usr/sbin/nfsd -t 8 -u 8 ; then
-
-[4] HPUX 9.X has a bad /bin/sh that runs out of fixed memory allocations.
-If you use the configure script, you must run it as
-
-	/bin/ksh ./configure
-
-Also, this system has a bad /bin/make that cannot handle VPATH well.  You
-cannot use --srcdir or the buildall script with it.  I suggest you install
-GNU make or configure locally with "/bin/ksh ./configure".
-
-Erez.
+[1] Due to limitations in the Sun autofs v1 implementation, some amd features
+cannot be properly supported. More precisely, trying to access a link mount
+pointing to another amd entry will result in failure and/or deadlock.
+Ordinary nfs and link mounts work well, however.
+
+[2] AIX autofs appears to be a variant of the Sun autofs v1 protocol, but
+IBM don't provide any sort of documentation or even header files from it.
+It is currently unsupported; we may add some experimental support for it at
+some point, though it won't be pretty. Assistance from IBM-ers would be
+highly appreciated, hint hint.
+
+[3] IRIX 6 autofs uses the Sun autofs v1 protocol, too.  The header files
+are part of the onc3_eoe.sw.autofs (IRIX 6.2) or nfs.sw.autofs (IRIX 6.5)
+package, which may not be installed.  The autofs code is known to compile,
+but hasn't been run yet.  SGI's autofsd uses a barely documented system
+call, syssgi(SGI_AUTOFS_SYS, ...), which may be required to get working
+autofs support.  Additional help from SGI would be highly appreciated.
+
+Erez & Ion
